unit MemStatusForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TfrmMemStatus = class(TForm)
    lblRTLBlocks: TLabel;
    lblRTLBytes: TLabel;
    lblTaskManWS: TLabel;
    lblTaskManVM: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Timer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  end;

implementation

{$R *.dfm}

{$ifdef ConditionalExpressions}
  {$Warn Symbol_Deprecated Off}
  {$Warn Symbol_Platform Off}
{$endif}

uses
  PSAPI;

procedure TfrmMemStatus.FormCreate(Sender: TObject);
begin
  TimerTimer(Timer); //make timer tick right at start
end;

procedure TfrmMemStatus.TimerTimer(Sender: TObject);
var
  Bytes, Blocks,
  TaskManWS, TaskManVM: Cardinal;
  PMC: TProcessMemoryCounters;
const
  KiloByte = 1024;
  MegaByte = KiloByte * KiloByte;

begin
  Blocks := AllocMemCount;
  Bytes := AllocMemSize;
  Win32Check(GetProcessMemoryInfo(GetCurrentProcess, @PMC, SizeOf(PMC)));
  lblRTLBlocks.Caption := Format('%.0n ($%x)', [Blocks * 1.0, Blocks]);
  lblRTLBytes.Caption := Format('%.0n ($%x) bytes, %.2n ($%x) kb',
    [Bytes * 1.0,        Bytes,
     Bytes * 1.0 / KiloByte, Bytes div KiloByte]);
  TaskManWS := PMC.WorkingSetSize;
  lblTaskManWS.Caption := Format(
    '%.0n ($%x) bytes, %.0n ($%x) kb, %.2n ($%x) Mb',
    [TaskManWS * 1.0, TaskManWS,
     TaskManWS / KiloByte, TaskManWS div KiloByte,
     TaskManWS / MegaByte, TaskManWS div MegaByte]);
  TaskManVM := PMC.PagefileUsage;
  lblTaskManVM.Caption := Format(
    '%.0n ($%x) bytes, %.0n ($%x) kb, %.2n ($%x) Mb',
    [TaskManVM * 1.0, TaskManVM,
     TaskManVM / KiloByte, TaskManVM div KiloByte,
     TaskManVM / MegaByte, TaskManVM div MegaByte]);
end;

initialization
  TfrmMemStatus.Create(Application)
end.
