unit MemoryConsumptionDemoU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TfrmMain = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    Timer1: TTimer;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses HelpIntfs;

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //Look for -hm or /hm, regardless of case
  Timer1.Enabled := FindCmdLineSwitch('hm', ['-', '/'], True)
end;

procedure TfrmMain.Timer1Timer(Sender: TObject);
var
  Code: Cardinal;
  Blocks, Bytes: Cardinal;
begin
  try
    Blocks := AllocMemCount;
    Bytes := AllocMemSize;
    Code := GetHeapStatus.HeapErrorCode;
    if Code = 0 then
      Caption := Format('%s (Blocks=%d Bytes=%d)',
        [Application.Title, Blocks, Bytes])
    else
    begin
      Caption := Format('(**Invalid Heap** code %d)', [Code]);
      (Sender as TTimer).Enabled := False
    end
  except
    Caption := '(**Invalid Heap** - code unknown)';
    (Sender as TTimer).Enabled := False
  end
end;

procedure TfrmMain.Button1Click(Sender: TObject);
begin
  with TEdit.Create(Self) do
  begin
    Text := TimeToStr(Time);
    Color := Random($1000000);
    Font.Color := $1000000 - Color;
    Left := Random(Panel1.Width - Width);
    Top := Random(Panel1.Height - Height);
    Parent := Panel1;
  end
end;

procedure TfrmMain.Button2Click(Sender: TObject);
begin
  if Panel1.ControlCount > 0 then
    Panel1.Controls[Random(Panel1.ControlCount)].Free
end;

procedure TfrmMain.Button3Click(Sender: TObject);
begin
  PInteger(Integer(Panel1)-4)^ := 400;
end;

initialization
  Randomize
end.
