unit NewMemoryManager;

interface

implementation

uses Windows;

var
  RTLMemMgr: TMemoryManager;

function NewGetMem(Size: Integer): Pointer;
begin
  Result := RTLMemMgr.GetMem(Size);
  //Uncomment this to hear the memory allocations as they occur
  Beep(300 + Size * 3, 1);
end;

function NewFreeMem(P: Pointer): Integer;
begin
  Result := RTLMemMgr.FreeMem(P);
end;

function NewReallocMem(P: Pointer; Size: Integer): Pointer;
begin
  Result := RTLMemMgr.ReallocMem(P, Size);
end;

const
  NewMemMgr: TMemoryManager = (
    GetMem: NewGetMem;
    FreeMem: NewFreeMem;
    ReallocMem: NewReallocMem);

initialization
  Assert(AllocMemCount = 0,
    'Replacement memory manager must be first' +
    'in the project file''s uses clause');
  GetMemoryManager(RTLMemMgr);
  SetMemoryManager(NewMemMgr)
finalization
  SetMemoryManager(RTLMemMgr)
end.
